<template>
	<div class="row">
		<div class="col-12">
			<label for="autocomplete-ayn" class="form-label text-secondary"
				>Apellido y Nombre</label
			>
		</div>
		<div class="col-md-10 pe-0">
			<div id="parent" class="form-group dropdown">
				<input
					id="autocomplete-ayn"
					type="text"
					class="form-control form-control-sm pt-1 pb-1"
					v-model.trim="usuarioInput"
					:disabled="searching"
				/>
				<div
					class="dropdown-menu"
					:class="{ show: showDropdown }"
					data-popper-placement="top-start"
				>
					<button
						type="button"
						class="dropdown-item"
						v-for="pers in personas"
						:value="pers.ayn"
						:key="pers.ayn"
						@click="select(pers)"
					>
						{{ pers.ayn }}
					</button>
				</div>
			</div>
		</div>
		<div class="col-2 ps-1">
			<div class="spinner-border" role="status" v-show="searching">
				<span class="visually-hidden">Loading...</span>
			</div>
		</div>
	</div>
</template>

<script lang="ts">
import { defineComponent } from "vue";
import http from "@/http";
import type { Persona } from "@/entities/Persona";
import shared from "@/shared.js";

const { urlApi } = shared();

export default defineComponent({
	name: "AutocompleteNombreApellido",
	props: ["modelValue"],
	emits: ["update:modelValue"],
	data() {
		return {
			usuarioInput: "" as string,
			persona: {} as Persona | undefined,
			personas: [] as Persona[],
			timer: 0 as number | undefined,
			showDropdown: false as boolean,
			searching: false as boolean,
		};
	},
	methods: {
		async search(value: string) {
			this.persona = undefined;
			this.showDropdown = false;
			if (this.personas.length == 0) {
				var rta = await http.get(urlApi + "findUser?nombre=" + value);
				if (rta.data.status == "success") {
					rta.data.res.forEach((persona: Persona) => {
						this.personas.push(persona);
					});
				}
			}
			if (this.personas.length > 0) {
				this.showDropdown = true;
			}
		},
		async select(persona: Persona) {
			this.persona = persona;
			this.usuarioInput = persona.ayn;
			this.showDropdown = false;
			this.personas = [];
			this.$emit("update:modelValue", persona);
		},
	},
	watch: {
		usuarioInput(newValue: string) {
			if (
				newValue.length >= 3 &&
				(typeof this.persona === "undefined" || this.persona.ayn != newValue)
			) {
				clearTimeout(this.timer);
				this.timer = setTimeout(async () => {
					this.searching = true;
					await this.search(newValue);
					this.searching = false;
				}, 1000);
			} else if (newValue.length == 0) {
				this.$emit("update:modelValue", undefined);
			}
		},
	},
});
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped></style>
